#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 2e5 + 100, INF = 1e18, K = 1e3;

struct segment_tree {
    int t[4 * N];

    void build(int v, int l, int r, vector<int> &a) {
        if (l == r) {
            t[v] = a[l];
        } else {
            int m = (r + l) / 2;
            build(v * 2, l, m, a);
            build(v * 2 + 1, m + 1, r, a);
            t[v] = max(t[v * 2], t[v * 2 + 1]);
        }
    }

    int get(int v, int l, int r, int tl, int tr) {
        if (l >= tl && r <= tr) {
            return t[v];
        }
        if (l > tr || r < tl) {
            return -INF;
        }
        int m = (r + l) / 2;
        return max(get(v * 2, l, m, tl, tr), get(v * 2 + 1, m + 1, r, tl, tr));
    }
};

int n, k, ans = -INF;
vector<int> a, pref, sufmax;
segment_tree tree;

void solve() {
    cin >> n >> k;
    a.resize(n);
    pref.resize(n + 1);
    sufmax.resize(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    tree.build(1, 0, n - 1, a);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i - 1];
    }
    sufmax[n] = n;
    for (int i = n - 1; i >= 0; i--) {
        sufmax[i] = sufmax[i + 1];
        if (pref[sufmax[i]] < pref[i]) {
            sufmax[i] = i;
        }
    }
    for (int i = 0; i < n; i++) {
        int sum = 0, ss = 0;
        multiset<int> se;
        for (int j = i; j < sufmax[i + 1]; j++) {
            se.insert(a[j]);
            ss += a[j];
            if (se.size() > k) {
                ss -= (*se.begin());
                sum += (*se.begin());
                se.erase(se.begin());
            }
            if (j - i + 1 >= k) {
                ans = max(ans, sum);
            }
        }
        if (sufmax[i + 1] - i >= k) {
            ans = max(ans, sum);
        }
//        ans = max(ans, pref[sufmax[i + 1]] - pref[i]);
    }
    cout << ans;
}